Subject: Re: Is it valid to add a macvlan virtual interface to a bridge? If so, there seems to be a bug with it.

From: Ben Greear <[email-masked]>
Date: Fri, 05 Dec 2008 09:43:25 -0800

Patrick McHardy wrote:

>> Should what I'm doing be working or possible? If not, could something
>> be added to the kernel to prevent macvlan interfaces being added to
>> bridge instances, to stop other people spending time trying to do what
>> I've tried to do?
> 
> Unfortunately one of both combinations will not work, no matter
> what we do. The bridge code could issue a warning when adding
> a bridge on top of a macvlan device, but there's no clean indication
> that something is a macvlan device besides dev->rtnl_link_ops->kind
> being "macvlan".

A mac-vlan can't really be PROMISC either since it only receives
BCAST frames and packets destined for it's own MAC, so I can't see
how it could work in a bridge....

user-space brctl could check for the driver string returned by
ethtool API to check if no one wants any additional cruft in
the kernel...

You might try using a pair of VETH interfaces to bridge between
your host and virtual host.

Thanks,
Ben

-- 
Ben Greear <[email-masked]>
Candela Technologies Inc  http://www.candelatech.com